unit uMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, stdctrls, ExtCtrls,
  XMLDoc, XMLIntf  ;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    procedure Button2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }

  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

{ TForm1 }

// XML   
procedure TForm1.Button1Click(Sender: TObject);
Var
  xdSoft : TXMLDocument;
  xnRoot  : IXMLNode;
  xnChild : IXMLNode;
  xnGrandchild : IXMLNode;
begin

  // XML Document 
  xdSoft := TXMLDocument.Create(Application);
  xdSoft.Active := True;
  xdSoft.Encoding:= 'euc-kr';

  // Ʈ  
  xnRoot := xdSoft.AddChild('SoftList');
  // 忡 Ӽ 
  xnRoot.Attributes['LatestUpdate'] := FormatDateTime('YYYY/MM/DD', Now);


  // ׽Ʈ  ߰

  // ###################################################################### //

  //  ؿ  
  xnChild := xnRoot.AddChild('Soft');
  xnChild.Attributes['Soft_name'] := 'PhotoSharp';

  xnGrandchild := xnChild.AddChild('Detail');
  xnGrandchild.Attributes['maker'] := 'Adove';
  xnGrandchild.Attributes['section']  := 'Drawing tool';
  xnGrandchild.Attributes['Price']  := 5000;

  xnGrandchild := xnChild.AddChild('Extra');
  xnGrandchild.Attributes['name'] := 'toy';
  xnGrandchild.Attributes['note']  := 'for child';

  xnGrandchild := xnChild.AddChild('Stock');
  //   
  xnGrandchild.NodeValue := 100;

  // ---------------------------------------------------------------------- //

  xnChild := xnRoot.AddChild('Soft');
  xnChild.Attributes['Soft_name'] := 'OverOffice';

  xnGrandchild := xnChild.AddChild('Detail');
  xnGrandchild.Attributes['maker'] := 'OverSoft';
  xnGrandchild.Attributes['section']  := 'office tool';
  xnGrandchild.Attributes['Price']  := 2000;

  xnGrandchild := xnChild.AddChild('Extra');
  xnGrandchild.Attributes['name'] := 'notebook';
  xnGrandchild.Attributes['note']  := 'no comment';

  xnGrandchild := xnChild.AddChild('Stock');
  xnGrandchild.NodeValue := 50;
{
  // ---------------------------------------------------------------------- //

  xnChild := xnRoot.AddChild('Soft');
  xnChild.Attributes['Soft_name'] := 'PowerCraft';

  xnGrandchild := xnChild.AddChild('Detail');
  xnGrandchild.Attributes['maker'] := 'Billiard';
  xnGrandchild.Attributes['section']  := 'game';
  xnGrandchild.Attributes['Price']  := 500;

  xnGrandchild := xnChild.AddChild('Extra');
  xnGrandchild.Attributes['name'] := 'mouse';
  xnGrandchild.Attributes['note']  := 'for gamer';

  xnGrandchild := xnChild.AddChild('Stock');
  xnGrandchild.NodeValue := 20;
}

  // ###################################################################### //

  // XML Document ϱ
  xdSoft.SaveToFile('C:\Test.Xml');
  xdSoft.Free;

end;

// XML  о
procedure TForm1.Button2Click(Sender: TObject);
Var
  xdSoft : TXMLDocument;
  xnChild : IXMLNode;
  xnGrandchild : IXMLNode;
  i : Integer;
  j : Integer;
  k : Integer;
  sMsg : string;
  sTest : string;
begin

  // XML Document 
  xdSoft := TXMLDocument.Create(Application);

  // XML Document ҷ
  xdSoft.LoadFromFile('C:\Test.Xml');
  xdSoft.Active := True;

  // Ʈ 尡   
  if xdSoft.ChildNodes.First = nil then Begin
    Exit;
  End;

  // Ʈ ִ 
  For i := 0 To xdSoft.DocumentElement.ChildNodes.count - 1 Do
  Begin
    sMsg := '';
    sTest := '';

    xnChild := xdSoft.DocumentElement.ChildNodes[i];
    xnGrandchild := xnChild.ChildNodes[0];

    // Soft  ù°   attribute 
    For j :=0 To xnGrandchild.AttributeNodes.Count - 1 Do
    begin

    sMsg := sMsg +
      '    ' + xnGrandchild.AttributeNodes.Get(j).NodeName + ' : ' +
      xnGrandchild.AttributeNodes.Get(j).NodeValue + #13

    end;
    sTest := sTest + xnChild.NodeName + ' : ';
    sTest := sTest + xnChild.AttributeNodes.Get(0).NodeValue + #13;

    xnGrandchild := xnChild.ChildNodes[2];

    ShowMessage(
      sTest + #13 +
      sMsg + '    ----------' + #13 +
      '    ' + xnGrandchild.NodeName + ' : ' +
      xnGrandchild.NodeValue
    );

  End;

  xdSoft.Free;

end;

end.
